\documentclass[a4paper,10pt]{article}

\usepackage{hyperref}
\usepackage{ucs}
\usepackage{graphicx}
\usepackage{pgf}

\begin{document}

\title{\textbf{Device detection}}
\author{Pawel Dziepak}
\date{\textit{April 4, 2009}}
\maketitle

\begin{abstract}
This article is a description of algorithms and data structures used to manage and store device information including automatic detection at the system startup and after registering new device driver.
\end{abstract}

\section{Introduction}
\paragraph{} \textit{to be completed}

\section{Device objects}
\paragraph{} In Quarn OS each device is represented as an object managed by the Manes system. \cite{manes_doc} The parent of each device and bus (except the root one) is the bus it is connected to. Manes allows to create hierarchy of devices that corresponds to the real connections between them, while accesing them is still very simple and doesn't need any knowledge about its position. From the client point of view devices are completely independent from each other whereas drivers can obtain specific information about buses and other relations that is needed to use hardware properly.
\subsection{Device drivers}
\paragraph{} Device drivers in Manes are registered as special object types. They can be added to the system at any time gaining control over previously detected (but unrecognized) devices. What makes them different to other types is abilitiy (and somehow obligation) to provide certain interface\footnote{In Quarn OS each type is in fact an object but in most cases its possibilities are significantly reduced. In fact only drivers are allowed to provide a minimalistic interface to check if they can communicate with a device.}.
\subsection{Device Identifiers}
\paragraph{} In order to let drivers communicate with devices DID (\textit{device identifier}) objects were introduced. They store bus-dependent information that are essential to access hardware. Each device and bus object stores reference to its own DID.
\paragraph{} DID may store either general information needed to access device directly or internal bus address that requires device driver to use bus driver in order to comunicate with attended piece of hardware. However a reference to the bus is always present.


\section{Bus initialization}
\paragraph{} \textit{to be completed}

\section{Detection algorithm}
\paragraph{} Device detection is performed while scanning bus in search for new devices. The whole procedure what happens when a device is found is presented on figure \ref{fig:devdet} and described below.
\paragraph{} If device is found, bus driver asks each possible drivers if they support it. At this stage device is represented only by its DID. To reduce performance hit drivers may be organized into groups assigned to certain buses or even device classes while the latter depends on the amount of information the bus provides.
\paragraph{} If a driver claims that it is able to manage the device, new object of appropiate type is created. At this point bus driver is permitted to continue bus scan while device initializtation can be performed asynchrously and does not affect other parts of the system.
\paragraph{} If there is no registered driver that recognize new device, an object of type \texttt{unknown} is created. It stores only DID and its own type information what may be needed when new driver is registered to check if it support that device.

\begin{figure}
\centering
\begin{center}
\includegraphics[width=50ex,height=41ex]{devicedetect.eps}
\end{center}
\caption{Device detection algorithm}
\label{fig:devdet}
\end{figure}


\section{Related work}
\paragraph{} \textit{to be completed}

\begin{thebibliography}{100}
\bibitem{manes_doc} P. Dziepak: \textit {Managed Execution System}, Quarn OS Documentation, 2009.
\end{thebibliography}

\end{document}
